package org.sample.nio.command;

import org.sample.nio.QuoteManager;
import org.sample.nio.response.handler.IResponseHandler;

/**
 * This class contain all the commons getter/setter for the commands
 * @author Sebastien Dionne
 *
 */
public abstract class BasicCommand implements ICommand {
	
	protected QuoteManager f_manager;
	protected IResponseHandler f_responseHandler;
	protected String f_quoteSubscription;
	
	
	public BasicCommand(QuoteManager manager){
		f_manager = manager;
	}
	
	/**
	 * @return the quoteSubscription
	 */
	public String getSubscription() {
		return f_quoteSubscription;
	}

	/**
	 * @param quoteSubscription the quoteSubscription
	 */
	public void setSubscription(String quoteSubscription) {
		f_quoteSubscription = quoteSubscription;
	}
	
	/**
	 * 
	 * @return le quoteManager
	 */
	public QuoteManager getQuoteManager() {
		return f_manager;
	}
	
	/**
	 * 
	 * @param manager QuoteManager
	 */
	public void setQuoteManager(QuoteManager manager) {
		f_manager = manager;
	}
	
	/**
	 * 
	 * @return response handler
	 */
	public IResponseHandler getResponseHandler() {
		return f_responseHandler;
	}
	
	/**
	 * 
	 * @param handler le handler qui va recevoir les responses
	 */
	public void setResponseHandler(IResponseHandler handler) {
		f_responseHandler = handler;
	}
	
}
