package org.sample.nio.command;

import org.sample.nio.QuoteManager;
import org.sample.nio.connection.handler.ClientConnectionHandler;
import org.sample.nio.response.handler.IResponseHandler;

public interface ICommand {

	/**
	 * process the query
	 * @param query query to send to 3th party
	 * @param clientConnectionHandler client that call the command
	 * @return BFTransactionReq the request
	 */
	ICommandRequest process(String query, ClientConnectionHandler clientConnectionHandler);
	
	/**
	 * 
	 * @param manager QuoteManager
	 */
	void setQuoteManager(QuoteManager manager);
	
	/**
	 * 
	 * @return quoteManager
	 */
	QuoteManager getQuoteManager();
	
	/**
	 * 
	 * @return response handler
	 */
	IResponseHandler getResponseHandler();
	
	/**
	 * 
	 * @param handler that will receive the updates
	 */
	void setResponseHandler(IResponseHandler handler);
	
	/**
	 * @return the quoteSubscription
	 */
	String getSubscription();

	/**
	 * @param quoteSubscription the quoteSubscription
	 */
	void setSubscription(String quoteSubscription);
}
