package org.sample.nio.command;

import org.sample.nio.dao.Quote;
import org.sample.nio.response.handler.IResponseHandler;

public interface ICommandRequest {
	
	/**
	 * Close the feed to the 3th party
	 */
	void close();
	
	/**
	 * 
	 * @return the requestID.  Used by the client to find
	 * the response is for which request
	 */
	int getRequestID();
	
	/**
	 * 
	 * @return the quoteSubscription
	 */
	String getQuoteSubscription();
	
	/**
	 * 
	 * @return the responseHandler that will receive the events
	 */
	IResponseHandler getResponseHandler();
	
	/**
	 * handle the quote receive
	 * @param quote the quote for the symbol requested
	 */
	void handleQuote(Quote quote);
	
}
