package org.sample.nio.queue;

import java.util.concurrent.BlockingQueue;

import org.sample.nio.QuoteManager;
import org.sample.nio.queue.dao.QueueCommand;

public class QuoteConsumer implements Runnable {

	protected BlockingQueue<QueueCommand> quoteBlockingQueue;
	protected boolean shutdown = false;
	protected QuoteManager manager;
	
	public QuoteConsumer(QuoteManager quoteManager, BlockingQueue<QueueCommand> quoteBlockingQueue){
		this.manager = quoteManager;
		this.quoteBlockingQueue = quoteBlockingQueue;
	}
	
	public void shutdown(){
		shutdown = true;
	}
	
	public void process(QueueCommand command){
		
		if(command!=null){
			
			manager.processQuery(command.getClientConnectionHandler(), command.getQuery());
			
		}
	}
	
	public void run() {
		
		while(!shutdown){
			try {
				QueueCommand command = quoteBlockingQueue.take();
				process(command);
			} catch (InterruptedException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}
	}

}
