package org.sample.nio.queue;

import java.util.List;
import java.util.Vector;
import java.util.concurrent.BlockingQueue;

import org.sample.nio.queue.dao.QueueCommand;

public class QuoteProducer implements Runnable {
	
	protected BlockingQueue<QueueCommand> quoteBlockingQueue;
	protected List<QueueCommand> waitingMessageList = new Vector<QueueCommand>();
	protected boolean shutdown = false;
	public static int sleepDelay = 100;
	
	public QuoteProducer(BlockingQueue<QueueCommand> quoteBlockingQueue){
		this.quoteBlockingQueue = quoteBlockingQueue;
	}
	
	public void shutdown(){
		shutdown = true;
	}
	
	public void addtoQueue(QueueCommand command){
		waitingMessageList.add(command);
	}
	
	public void run() {
		
		while(!shutdown){
			try {
				if(!waitingMessageList.isEmpty()){
					QueueCommand command = waitingMessageList.remove(0);
					quoteBlockingQueue.put(command);
				} else {
					Thread.sleep(sleepDelay);
				}
			} catch (InterruptedException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}
	}
	
}
