package org.sample.nio.response;

import org.sample.nio.dao.Quote;

/**
 * This class simulate a request to the 3th party
 * 
 * The quote are simulated by a Thread in the class.
 * 
 * 
 * @author Sebastien Dionne
 *
 */
public class FeedCommandRequest extends QuoteCommandRequest {
	
	private boolean shutdown = false;
	
	public FeedCommandRequest(){
		super();
	}
	
	@Override
	public void close() {
		shutdown = true;
	}
	
	public void startGenerateQuote(){
		
		Thread t = new Thread(new Runnable(){ public void run(){
			
			while(!shutdown){
				try {
					double bid = 50 * Math.random() + 1;
					double ask = 50 * Math.random() + 1;
					
					// send the generated quote to client
					handleQuote(new Quote(getQuoteSubscription(),bid,ask));
					Thread.currentThread().sleep(500);
				} catch(Exception e){
					e.printStackTrace();
				}
			}
		}
			
		});
		
		// wait 1 sec.. simulate a little delay
		try {
			Thread.sleep(1000);
		} catch(Exception e){
			e.printStackTrace();
		}
		
		t.start();
		
	}

	/*
	 * (non-Javadoc)
	 * @see org.sample.nio.response.QuoteCommandRequest#handleQuote(org.sample.nio.dao.Quote)
	 */
	public void handleQuote(Quote quote){
		// send the generated quote to client
		StringBuffer sb = new StringBuffer(quote.toString());
		
		getResponseHandler().sendToClient(sb);
		
	}
}
