package org.sample.nio.response.handler;

import java.io.IOException;
import java.nio.ByteBuffer;
import java.util.Iterator;
import java.util.List;

import org.sample.nio.connection.handler.ClientConnectionHandler;

/**
 * This class handler the response.
 * 
 * The response will be send to the client.
 * 
 * @author Sebastien Dionne
 *
 */
public class FeedResponseHandler extends QuoteResponseHandler {


	@Override
	public void sendLastUpdateToClient(ClientConnectionHandler clientConnectionHandler) {
		// not implemented in this demo
	}

	@Override
	public void sendToClient(StringBuffer sb) {
		
		ByteBuffer writeBuffer = ByteBuffer.allocate(sb.toString().getBytes().length);
		
		String quoteSubcription = getCommand().getSubscription();
		
		List<ClientConnectionHandler> list = getCommand().getQuoteManager().getClientHandlerByQuoteSubcription(quoteSubcription);
		
		// HOW to skip the clientConnectionHandler if it was closed ?
		
		if(list!=null){
			for (Iterator<ClientConnectionHandler> iterator = list.iterator(); iterator.hasNext();) {
				ClientConnectionHandler clientConnectionHandler = iterator.next();
				
				writeBuffer.put(sb.toString().getBytes());
				writeBuffer.flip();
				
				System.out.println("SENDING FEED TO CLIENT = [" + sb.toString() + "]");
				
				try {
					if(clientConnectionHandler.getSocketChannel().isConnected()){
						clientConnectionHandler.getSocketChannel().write(writeBuffer);
					}
				} catch (IOException e) {
					e.printStackTrace();
					// something obtain this error
					
					// java.nio.channels.ClosedChannelException
					
					// le client n'est pas connecte
					clientConnectionHandler.close();
				}
				
				writeBuffer.rewind();
				
			}
		}
	}

}
