package org.sample.nio.response.handler;

import org.sample.nio.command.ICommand;
import org.sample.nio.command.ICommandRequest;
import org.sample.nio.connection.handler.ClientConnectionHandler;

public interface IResponseHandler {
	
	/**
	 * Client that will receive the response
	 * @param clientConnectionHandler clientHandler
	 */
	void setClientConnectionHandler(ClientConnectionHandler clientConnectionHandler);
	
	/**
	 * 
	 * @return Client that will receive the response
	 */
	ClientConnectionHandler getClientConnectionHandler();
	
	/**
	 * 
	 * @param command that has been asked
	 */
	void setCommand(ICommand command);
	
	/**
	 * 
	 * @return the command  that has been asked
	 */
	ICommand getCommand();
	
	/**
	 * 
	 * @param commandRequest the commandRequest
	 */
	void setCommandRequest(ICommandRequest commandRequest);
	
	/**
	 * 
	 * @return the commandRequest
	 */
	ICommandRequest getCommandRequest();
	
	/**
	 * Send the response to the client registed
	 * @param sb message to send
	 */
	void sendToClient(StringBuffer sb);
	
	/**
	 * Send the last update for this feed to this client
	 * @param clientConnectionHandler client that will receive the last update
	 */
	void sendLastUpdateToClient(ClientConnectionHandler clientConnectionHandler);
}
