package org.sample.nio.response.handler;

import java.io.IOException;
import java.nio.ByteBuffer;

import org.sample.nio.command.ICommand;
import org.sample.nio.command.ICommandRequest;
import org.sample.nio.command.QuoteCommand;
import org.sample.nio.connection.handler.ClientConnectionHandler;

/**
 * This class handler the response.
 * 
 * The response will be send to the client.
 * 
 * @author Sebastien Dionne
 *
 */
public class QuoteResponseHandler implements IResponseHandler {

	private QuoteCommand f_command;
	private ClientConnectionHandler f_clientConnectionHandler;
	private ICommandRequest f_commandRequest;
	
	
	@Override
	public ClientConnectionHandler getClientConnectionHandler() {
		return f_clientConnectionHandler;
	}

	@Override
	public ICommand getCommand() {
		return f_command;
	}

	@Override
	public ICommandRequest getCommandRequest() {
		return f_commandRequest;
	}

	@Override
	public void sendLastUpdateToClient(ClientConnectionHandler clientConnectionHandler) {
		// not implemented in this demo
	}

	@Override
	public void sendToClient(StringBuffer sb) {
		
		ByteBuffer writeBuffer = ByteBuffer.allocateDirect(sb.toString().getBytes().length);
		
		writeBuffer.put(sb.toString().getBytes());
		
		writeBuffer.flip();
		
		System.out.println("SENDING QUOTE TO CLIENT =" + sb.toString());
		
		try {
			getClientConnectionHandler().getSocketChannel().write(writeBuffer);
			/*
			int len = socketChannel.write(byteBuffer);
			if (len == 0) {
			if (writeSelector == null){
				writeSelector = SelectorFactory.getSelector();
			}
			key = socketChannel.register
			(writeSelector, key.OP_WRITE);
				if (writeSelector.select(30 * 1000) == 0) {
					throw new IOException("Client disconnected");
				}
			}
			*/
			
			
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

	@Override
	public void setClientConnectionHandler(ClientConnectionHandler clientConnectionHandler) {
		f_clientConnectionHandler = clientConnectionHandler;
	}

	@Override
	public void setCommand(ICommand command) {
		f_command = (QuoteCommand)command;
	}

	@Override
	public void setCommandRequest(ICommandRequest commandRequest) {
		f_commandRequest = commandRequest;
	}

}
